/**
 * Locator.java
 *
 * File generated from the XValidator4::Locator uml Class
 * Generated by IHE - europe, gazelle team
 */
package net.ihe.gazelle.xvalidation.core.model;

// End of user code
import javax.persistence.*;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlAttribute;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlTransient;
import javax.xml.bind.annotation.XmlType;

import org.hibernate.annotations.Type;
import org.w3c.dom.Node;

/**
 * Description of the class Locator.
 *
 */

@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "Locator", propOrder = { "appliesOn", "path" })
@XmlRootElement(name = "Locator")
@Entity
@Inheritance(strategy = InheritanceType.SINGLE_TABLE)
@Table(name = "xval_locator", schema = "public")
@SequenceGenerator(name = "xval_locator_sequence", sequenceName = "xval_locator_id_seq")
public class Locator implements java.io.Serializable {

	/**
	 *
	 */
	private static final long serialVersionUID = 4265308925626375158L;

	@Id
	@GeneratedValue(generator = "xval_locator_sequence", strategy = GenerationType.SEQUENCE)
	@Column(name = "id", nullable = false, unique = true)
	@XmlTransient
	private Integer id;

	@Column(name = "applies_on", nullable = false)
	@XmlAttribute(name = "appliesOn", required = true)
	private String appliesOn;

	@Column(name = "path", nullable = false)
	@Lob
	@Type(type = "text")
	@XmlAttribute(name = "path", required = true)
	private String path;

	/**
	 * An attribute containing marshalled element node
	 */
	@XmlTransient
	@Transient
	private org.w3c.dom.Node xmlNodePresentation;

	public Locator(String docKeyword, String inPath) {
		this.appliesOn = docKeyword;
		this.path = inPath;
	}

	public Locator() {

	}

	public Locator(Locator locator1) {
		this.appliesOn = locator1.getAppliesOn();
		this.path = locator1.getPath();
	}

	/**
	 * Return appliesOn.
	 * 
	 * @return appliesOn
	 */
	public String getAppliesOn() {
		return appliesOn;
	}

	/**
	 * Set a value to attribute appliesOn.
	 * 
	 * @param appliesOn
	 *            .
	 */
	public void setAppliesOn(String appliesOn) {
		this.appliesOn = appliesOn;
	}

	/**
	 * Return path.
	 * 
	 * @return path
	 */
	public String getPath() {
		return path;
	}

	/**
	 * Set a value to attribute path.
	 * 
	 * @param path
	 *            .
	 */
	public void setPath(String path) {
		this.path = path;
	}

	public Node getXmlNodePresentation() {
		if (xmlNodePresentation == null) {
			xmlNodePresentation = ObjectFactory.getXmlNodePresentation("", "Locator", this);
		}
		return xmlNodePresentation;
	}

	public void setXmlNodePresentation(Node xmlNodePresentation) {
		this.xmlNodePresentation = xmlNodePresentation;
	}

	@Override
	public String toString() {
		StringBuilder builder = new StringBuilder();
		builder.append(this.appliesOn);
		builder.append("::");
		builder.append(this.path);
		return builder.toString();
	}

	public Integer getId() {
		return id;
	}

	public void setId(Integer id) {
		this.id = id;
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = (prime * result) + ((appliesOn == null) ? 0 : appliesOn.hashCode());
		result = (prime * result) + ((path == null) ? 0 : path.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj) {
			return true;
		}
		if (obj == null) {
			return false;
		}
		if (getClass() != obj.getClass()) {
			return false;
		}
		Locator other = (Locator) obj;
		if (appliesOn == null) {
			if (other.appliesOn != null) {
				return false;
			}
		} else if (!appliesOn.equals(other.appliesOn)) {
			return false;
		}
		if (path == null) {
			if (other.path != null) {
				return false;
			}
		} else if (!path.equals(other.path)) {
			return false;
		}
		return true;
	}

	public boolean isValued() {
		boolean appliesOnIsValued = (appliesOn != null && !appliesOn.isEmpty());
		boolean pathIsValued = (path != null && !path.isEmpty());
		return appliesOnIsValued && pathIsValued;
	}

}